%This file determines if the Hessian is +ve definitate
%Neil Gadhok
%v2.0 November 5, 2004

%(1) p(y) = c/cosh(y), h(y) = tanh(y),  h'(y) = sech^2(y). Thus, d/du(tanh(wx -u) = -sech(wx-u)? 
%(2) p(y) = c*exp(-.25 * y^4), h(y) = y^3, h'(y) = 3y^2, Thus, d/du((wx-u))^3) = 3y^2??

function cond =BetaD_Cond(m,n,W,u,x,c,d,B);


% m = 2;
% n = 100;
% W = diag(ones(1,m));
% u = zeros(m,1);
% x = randn(m,n);
% c = 1;
% d = .25;
% B = .28;


for i = 1:m,



%Calculate z_i
z_i = zeros(n);
for j=1:n,
    z_i(j) = W(i,:)*x(:,j) - u(i);
end


%calculate v_i

v_i_a = zeros(n,1);
v_i_b = zeros(n,1);
for j = 1:n,
   v_i_a(j) =  (c*exp(-d*(z_i(j)^4))^B)*z_i(j);
   v_i_b(j) =  (c*exp(-d*(z_i(j)^4))^B);
end

v_i(i) = (1/n)*(sum(v_i_a))*(1/n)*(sum(v_i_b));


%calculate r_i

r_i_a = zeros(n,1);
r_i_b = zeros(n,1);

%Note did this for h' of w.
for j = 1:n,
    r_i_a(j) = (c*exp(-d*(z_i(j)^4))^B)* ( 3*z_i(j)^2 - B*((z_i(j)^3)^2) ) * z_i(j);
    r_i_b(j) = (c*exp(-d*(z_i(j)^4))^B)* ( 3*z_i(j)^2 - B*((z_i(j)^3)^2) );
end

r_i(i) = ((1/n)*sum(r_i_a)) / ((1/n)*sum(r_i_b));


%calculate sigma_i_sqrd

sigma_i_sqrd_a = zeros(n,1);
sigma_i_sqrd_b = zeros(n,1);

for j = 1:n,
    sigma_i_sqrd_a(j) = (c*exp(-d*(z_i(j)^4))^B) * ((z_i(j)-v_i(i))^2);
    sigma_i_sqrd_b(j) = (c*exp(-d*(z_i(j)^4))^B) ;
    
end

sigma_i_sqrd(i) = ((1/n)*sum(sigma_i_sqrd_a))/((1/n)*sum(sigma_i_sqrd_b));

%calculate k_i

k_i_a = zeros(n,1);
k_i_b = zeros(n,1);

for j = 1:n,
    k_i_a(j) = (c*exp(-d*(z_i(j)^4))^B)* ( 3*z_i(j)^2 - B*((z_i(j)^3)^2) );
    k_i_b(j) = (c*exp(-d*(z_i(j)^4))^B) ;
end

k_i(i) = ((1/n)*sum(k_i_a))/((1/n)*sum(k_i_b));

%calculate m_i

m_i_a = zeros(n,1);
m_i_b = zeros(n,1);

for j = 1:n,
    m_i_a(j) = (c*exp(-d*(z_i(j)^4))^B)* ( 3*z_i(j)^2 - B*((z_i(j)^3)^2) ) * ((z_i(j)-v_i(i))^2);
    m_i_b(j) = (c*exp(-d*(z_i(j)^4))^B) ;
end

m_i(i) = ((1/n)*sum(m_i_a))/((1/n)*sum(m_i_b));

%calculate cb

pif = ones(1,n);
for i = 1:m,
    for j = 1:n,
        %(1) pif(j) = pif(j) * ((c/cosh( Wf(i,:)*xf(:,j) - uf(i)) )^Bf);
        pif(j) = pif(j) *  ( ( c*exp(-d* (W(i,:)*x(:,j) - u(i))^4) )^B );
    end
end


end %for i = 1:m,

cb = ( B/(B + 1) ) * ( ((2*(d^.25)*(gamma(.25)^-1))^B) * ((1+B)^-.25) ) * ( 1/( (1/n) * sum(pif) ) );


%Conditions


for i =1:m
   if ~((1 + B) - cb*(1-B) + m_i(i) - k_i(i)*((r_i(i)-v_i(i))^2) > 0)
       warning('Error 1');
   end
   
   if ~(k_i(i) > 0)
       warning('Error 2');
   end
   
   for j = 1:m
       if ~(sigma_i_sqrd(i)*sigma_i_sqrd(j)*k_i(i)*k_i(j) > ((1-B)^2)*((1-cb)^2))
            warning('Error 3');
        end
    end
end


cond = 0;
