%This function takes a demixing matrix W, and plots the estimate of the independent directions.
%It also takes as input the linestyle,linewidth and color to be plotted. 
%Only does 2d plots, and accepts 2x2 matrices.
%
%Neil Gadhok, v2.0, November 5, 2004.

function results  = BetaD_Ind_plot(W,DataSetMean,ymin,ymax,Linewidth,Linestyle,Colour);

results = 1;

Intersect = (W)*DataSetMean;
for i = 1:2,
    warning off;    %To get rid of silly warning.
    slope =  W(1,i)/W(2,i);
    warning on;
    if isinf(slope)
        H = line(ones(10,1)*DataSetMean(i),linspace(ymin,ymax,10));
    else
        H = refline(slope,Intersect(1) - slope*Intersect(2));
    end
    set(H,'Color',Colour,'LineWidth',Linewidth,'LineStyle',Linestyle);
end
results = 0;
