%This function creates the likelihood landscape for a specific dataset for BetaD.
%Neil Gadhok, v2.0, November 5, 2004
clear all


%DataSet 1
% n = 100;
% DataSet1 =  gamrnd(1.5,3,2,n-2); %alpha,beta,M,N
% DataSetMean = mean(DataSet1,2);
% DataSet1 = [DataSet1(1,:),25; DataSet1(2,:),25]; %Outlier #1
% DataSet1 = [DataSet1(1,:),25; DataSet1(2,:),25]; %Outlier #2
% DataSetMax = max(abs(DataSet1'));

% %DataSet 2
n = 200;
DataSet2 = [load_srcdat('E:\Thesis\Code\CCECE06\Fisher_Data\Unimodal_2src\epd_125_0219.dat',1,150);load_srcdat('E:\Thesis\Code\CCECE06\Fisher_Data\Unimodal_2src\epd_145_0281.dat',1,150)]; %Load Exponential Power Distribution
DataSet_BivarNorm = binorm(0,0,4,4,.8,50);
DataSetMean = mean(DataSet2,2);
DataSet2 = [DataSet2(1,:),DataSet_BivarNorm(1,:); DataSet2(2,:),DataSet_BivarNorm(2,:)];
DataSetMax = max(abs(DataSet2'));

p_i(1:2) = 1;  %1 for Dataset 2, 2 for dataset 1
s = DataSet2;  %s is a row vector
A = [1,0;0,1]; %A is the mixing matrix
x = A*s;       %x is our observation matrix.

u = mean(x,2);
m = 2;

%Betas = [0.0001,0.001,0.01,0.1];
%Betas = [0.04,0.12,0.20,0.28];
%Betas = [0.02,0.06,0.10,0.14];
N1 = 10;
N = 50;
Betas = linspace(0,.5,N1);
Likelihood = zeros(N,N);
API = zeros(N,N);

%Create phi's

phi1 = linspace(-pi,pi,N);
phi2 = linspace(-pi,pi,N);

B = 0.30;


%Create W's
W = zeros(m,m,N,N);
for i = 1:N,
    i
    for j = 1:N
        W(1,1,i,j) = cos(phi1(i));
        W(2,1,i,j) = sin(phi1(i));
        W(1,2,i,j) = cos(phi2(j));
        W(2,2,i,j) = sin(phi2(j));
        Likelihood(i,j) = -BetaD_Lbeta(x,W(:,:,i,j),u,B,p_i);  %In reality it should be a maximum likelihood.
        API(i,j) = Amari(A*W(:,:,i,j));
        
    end
end

figure;
surf(phi1,phi2,Likelihood);
shading flat;
view(2);
colorbar;
axis tight;
title('Likelihood');
xlabel('\phi_1');
ylabel('\phi_2');
colormap(gray);


Experiment_name = ['e:\Thesis\Results\',date,'\Likelihood'];
status = mkdir('e:\Thesis\Results\',date);
saveas(gcf,Experiment_name,'fig');
opts = struct('bounds','tight','Renderer','painters','linestylemap',[],'width',5.3,'height',4,'fontmode','fixed', 'BoundsCode','mcode','fontsize',10,'LineWidth',1,'format','eps','Color','rgb','Resolution',300); %Width is 6inches
setpref('exportfig','defaults',opts);
exportfig(gcf,Experiment_name); 

opts = struct('bounds','tight','Renderer','painters','linestylemap',[],'width',5.3,'height',4,'fontmode','fixed', 'BoundsCode','mcode','fontsize',10,'LineWidth',1,'format','png','Color','rgb','Resolution',300); %Width is 6inches
setpref('exportfig','defaults',opts);
exportfig(gcf,Experiment_name); 


figure;
surf(phi1,phi2,API);
shading flat;
view(2);
colorbar;
axis tight;
title('Amari');
xlabel('\phi_1');
ylabel('\phi_2');
colormap(gray);

Experiment_name = ['e:\Thesis\Results\',date,'\Amari'];
status = mkdir('e:\Thesis\Results\',date);
saveas(gcf,Experiment_name,'fig');
opts = struct('bounds','tight','Renderer','painters','linestylemap',[],'width',5.3,'height',4,'fontmode','fixed', 'BoundsCode','mcode','fontsize',10,'LineWidth',1,'format','eps','Color','rgb','Resolution',300); %Width is 6inches
setpref('exportfig','defaults',opts);
exportfig(gcf,Experiment_name); 

opts = struct('bounds','tight','Renderer','painters','linestylemap',[],'width',5.3,'height',4,'fontmode','fixed', 'BoundsCode','mcode','fontsize',10,'LineWidth',1,'format','png','Color','rgb','Resolution',300); %Width is 6inches
setpref('exportfig','defaults',opts);
exportfig(gcf,Experiment_name); 