%This function creates the likelihood landscape for a specific dataset for BetaD.
%Neil Gadhok, v2.0, November 5, 2004
function result = BetaD_LandscapeFunc(x,A,B,p_i,N)


result = 0;

u = mean(x,2);
m = 2;
N1 = 10;


Likelihood = zeros(N,N);
API = zeros(N,N);

%Create phi's

phi1 = linspace(-pi,pi,N);
phi2 = linspace(-pi,pi,N);



%Create W's
W = zeros(m,m,N,N);
for i = 1:N,
    i
    for j = 1:N
        W(1,1,i,j) = cos(phi1(i));
        W(2,1,i,j) = sin(phi1(i));
        W(1,2,i,j) = cos(phi2(j)); %Fixed this
        W(2,2,i,j) = sin(phi2(j)); %Fixed this
        Likelihood(i,j) = BetaD_Lbeta(x,W(:,:,i,j),u,B,p_i);  %In reality it should be a maximum likelihood.
        API(i,j) = Amari(A*W(:,:,i,j));
        
    end
end

figure;
surf(phi1,phi2,Likelihood);
shading flat;
view(2);
colorbar;
axis tight;
title(['Likelihood with \beta = ',num2str(B)]);
xlabel('\phi_1');
ylabel('\phi_2');
colormap(gray);


Experiment_name = ['e:\Thesis\Results\',date,'\Likelihood'];
%mkdir('e:\Thesis\Results\',date);
saveas(gcf,Experiment_name,'fig');
opts = struct('bounds','tight','Renderer','painters','linestylemap',[],'width',5.3,'height',4,'fontmode','fixed', 'BoundsCode','mcode','fontsize',10,'LineWidth',1,'format','eps','Color','rgb','Resolution',300); %Width is 6inches
setpref('exportfig','defaults',opts);
exportfig(gcf,Experiment_name); 

opts = struct('bounds','tight','Renderer','painters','linestylemap',[],'width',5.3,'height',4,'fontmode','fixed', 'BoundsCode','mcode','fontsize',10,'LineWidth',1,'format','png','Color','rgb','Resolution',300); %Width is 6inches
setpref('exportfig','defaults',opts);
exportfig(gcf,Experiment_name); 


figure;
surf(phi1,phi2,API);
shading flat;
view(2);
colorbar;
axis tight;
title('Amari');
xlabel('\phi_1');
ylabel('\phi_2');
colormap(gray);

Experiment_name = ['e:\Thesis\Results\',date,'\Amari'];
%mkdir('e:\Thesis\Results\',date);
saveas(gcf,Experiment_name,'fig');
opts = struct('bounds','tight','Renderer','painters','linestylemap',[],'width',5.3,'height',4,'fontmode','fixed', 'BoundsCode','mcode','fontsize',10,'LineWidth',1,'format','eps','Color','rgb','Resolution',300); %Width is 6inches
setpref('exportfig','defaults',opts);
exportfig(gcf,Experiment_name); 

opts = struct('bounds','tight','Renderer','painters','linestylemap',[],'width',5.3,'height',4,'fontmode','fixed', 'BoundsCode','mcode','fontsize',10,'LineWidth',1,'format','png','Color','rgb','Resolution',300); %Width is 6inches
setpref('exportfig','defaults',opts);
exportfig(gcf,Experiment_name); 

result = 1;