%This function creates the likelihood landscape video for a specific dataset for BetaD.
%Neil Gadhok, v2.0, November 2004.
clear all


%DataSet 1
% n = 100;
% DataSet1 =  gamrnd(1.5,3,2,n-2); %alpha,beta,M,N
% DataSetMean = mean(DataSet1,2);
% DataSet1 = [DataSet1(1,:),25; DataSet1(2,:),25]; %Outlier #1
% DataSet1 = [DataSet1(1,:),25; DataSet1(2,:),25]; %Outlier #2
% DataSetMax = max(abs(DataSet1'));

%DataSet 2
n = 200;
DataSet2 = [load_srcdat('epd_125_0219.dat',1,150);load_srcdat('epd_145_0281.dat',1,150)]; %Load Exponential Power Distribution
DataSet_BivarNorm = binorm(0,0,4,4,.8,50);
DataSetMean = mean(DataSet2,2);
DataSet2 = [DataSet2(1,:),DataSet_BivarNorm(1,:); DataSet2(2,:),DataSet_BivarNorm(2,:)];
DataSetMax = max(abs(DataSet2'));

p_i(1:2) = 1;  
s = DataSet2;  %s is a row vector
A = [1,0;0,1]; %A is the mixing matrix
x = A*s;       %x is our observation matrix.

u = mean(x,2);
m = 2;

%Betas = [0.0001,0.001,0.01,0.1];
%Betas = [0.04,0.12,0.20,0.28];
%Betas = [0.02,0.06,0.10,0.14];
N1 = 10;
N = 50;
Betas = linspace(0,.5,N1);
Likelihood = zeros(N,N);
API = zeros(N,N);

%Create phi's

phi1 = linspace(-pi,pi,N);
phi2 = linspace(-pi,pi,N);

figure;


for k = 1:10,
    B = Betas(k);
    
    
    %Create W's
    W = zeros(m,m,N,N);
    for i = 1:N,
        i
        for j = 1:N
            W(1,1,i,j) = cos(phi1(i));
            W(2,1,i,j) = sin(phi1(i));
            W(1,2,i,j) = cos(phi2(j));
            W(2,2,i,j) = sin(phi2(j));
            Likelihood(i,j) = BetaD_Lbeta(x,W(:,:,i,j),u,B,p_i);
            API(i,j) = Amari(A*W(:,:,i,j));
            
        end
    end
    set(gca,'nextplot','replacechildren');
    surf(phi1,phi2,Likelihood);
    shading flat;
    view(2);
    colorbar;
    title(['Likelihood ','\beta = ', num2str(B)]);
    F(k) = getframe;
    
end

% figure;
% surf(phi1,phi2,Likelihood);
% view(2);
% colorbar;
% title('Likelihood');
% 
% figure;
% surf(phi1,phi2,API);
% view(2);
% colorbar;
% title('Amari');
