% This function calculates the b_beta(W) equation. See page 1865 of
% M. Mihoko and S. Eguchi, "Robust blind source separation by beta
% divergence," Neural Computation, vol. 14, pp. 1859-1886, 2002.
%
%Neil Gadhok, v1.0, November 5, 2004.

function result = BetaD_bB(W,B,p_i)

switch p_i
case {1}, %p(z) = c exp(d z^4)
    d = .25;
    result = (abs(det(W))^B) * ( ((2*(d^.25)*(gamma(.25)^-1))^B) * ((1+B)^-.25) ) * (1/(B+1));
case {2}, %p(z) = c/cosh(z)
    %int(int(((pi./cosh(x)).*(pi./cosh(y))),x,-10,10),y,-10,10)
    %dblquad(inline('((pi./cosh(x)).*(pi./cosh(y))).^(1+.05)'), -25, 25, -25, 25)
    %x = [102.1,112,127,178];
    %y = [1.05,1.14,1.25,1.5];
    %polyfit(log(y),log(x),2)
    %1.6575    0.8034    4.5834
    %exp(polyval(polyfit(log(y),log(x),2),log(.5)))
    %d = exp(polyval([1.6575,0.8034,4.5834],log(B+1)));
    %result = (abs(det(W))^B) * d * (1/(B+1));
    result = 0;
otherwise
    warning('invalid number')
    result = 0;
end

