%This function takes in (a scalar, vector or matrix) and a number for
%a specfic density function and returns the result.
%
%Neil Gadhok, v1.0, November 5, 2004

function result = BetaD_p_i(z,p_i)

%Use set c to 1 and use quadl('BetaD_p_i(z,2)',-3,3) to determine constants. c = 1/ans

switch p_i
case {1}, %p(z) = c exp (-d z^4)
    c = sqrt(2)*(gamma(.25)^-1); 
    d = .25; %As d decreases, the distribution becomes more subgaussian (flat). Symmetric
    result = c.*exp(-d .*((z).^4));
case {2}, %p(z) = c/cosh(z)
    c = 1/pi;
    result = c./(cosh(z));
otherwise
    warning('invalid number')
    result = 0;
end
