%Generates Bivariate Normal data
%N. Gadhok v2.0, November 5, 2004.
%
%Input binorm(xm,ym,xsig,ysig,rho,n);
%xm - mean of x
%ym - mean of y
%xsig - standard deviation of x
%ysig - standard deviation of y
%rho - Correlation coefficent between x and y
%n - number of sample points

% Program  binorm.m
function data = binorm(xm,ym,xsig,ysig,rho,n);

x=[ ];
y=[ ];
for i = 1:n,
    a=randn;
    x1=xm+xsig*a;
    y1=ym+rho*ysig*a+ysig*randn*sqrt(1-rho*rho);
    x=[x x1];
    y=[y y1];
end;
data = [x;y];
